<?php
if (!defined('ABSPATH'))
		exit;
define('BP_MC_CORE_IS_INSTALLED', 1);
define('BP_MC_CORE_VERSION', '0.0.3');
define('BP_MC_CORE_DB_VERSION', '1');
class MC_mc_core extends MCA {
		function __construct(&$MC) {
				$this->MC = (object) $MC;
				$this->setup();
				define('BP_MC_CORE_PLUGIN_INCLUDES_DIR', WP_PLUGIN_DIR . '/' . MC_PLUGIN_DIR . '/includes/' . $this->MC->core->path);
				$includes = array(
						'/mc-core-functions.php'
				);
				parent::includes(BP_MC_CORE_PLUGIN_INCLUDES_DIR, $includes);
				add_action('admin_menu', array(
						&$this,
						'admin_menu_page'
				));
				add_action('wp_before_admin_bar_render', array(
						&$this,
						'mc_nav'
				));
				wp_register_style('mc-core', plugins_url(MC_PLUGIN_DIR . '/includes/' . $this->MC->core->path . '/css/mc-core.css'), array(), '20120208', 'all');
				wp_enqueue_style('mc-core');
				wp_enqueue_script('mc-core', plugins_url(MC_PLUGIN_DIR . '/includes/' . $this->MC->core->path . '/js/mc-core.js'));
				add_action('wp_ajax_mc_log', array(
						&$this,
						'mc_ajax_log'
				));
		}
		function save($parameter = "replace") {
				parent::save($this->MC, $parameter);
		}
		function __destruct() {
		}
		function setup() {
				if (!isset($this->MC->core)) {
						$this->MC->core = new stdClass;
				} //!isset($this->MC->core)
				if (!isset($this->MC->core->name)) {
						$this->MC->core->name = __("Core", "minecraft-admin");
				} //empty($this->MC->core)
				if (!isset($this->MC->core->beschreibung)) {
						$this->MC->core->beschreibung = __("This component can't be disabled. It makes the Minecraft Admin plugin work.", "minecraft-admin");
				} //empty($this->MC->core)
				if (!isset($this->MC->core->version)) {
						$this->MC->core->version = BP_MC_CORE_VERSION;
				} //empty($this->MC->core)
				if (!isset($this->MC->core->path)) {
						$this->MC->core->path = "mc-core";
				} //empty($this->MC->core)
				if (!isset($this->MC->core->aktive)) {
						$this->MC->core->aktive = "ja";
				} //empty($this->MC->games)
				if (!isset($this->MC->core->webserveruser) or $this->MC->core->webserveruser == "") {
						$this->MC->core->webserveruser = "www-data";
				} //!isset($this->MC->core->webserveruser) or $this->MC->core->webserveruser == ""
				if (!isset($this->MC->core->pfad) or $this->MC->core->pfad == "") {
						$this->MC->core->pfad = WP_PLUGIN_DIR . '/' . MC_PLUGIN_DIR . '/includes/' . $this->MC->core->path . "/minecraft-dir/";
				} //!isset($this->MC->core->pfad) or $this->MC->core->pfad == ""
				if (!isset($this->MC->core->jar) or $this->MC->core->jar == "") {
						$this->MC->core->jar = "craftbukkit.jar";
				} //!isset($this->MC->core->jar) or $this->MC->core->jar == ""
				if (!isset($this->MC->core->worlds) or $this->MC->core->worlds == "") {
						$this->MC->core->worlds = "world,world_nether";
				} //!isset($this->MC->core->worlds) or $this->MC->core->worlds == ""
				if (!isset($this->MC->core->cpu) or $this->MC->core->cpu == "") {
						$this->MC->core->cpu = "1";
				} //!isset($this->MC->core->cpu) or $this->MC->core->cpu == ""
				if (!isset($this->MC->core->ram) or $this->MC->core->ram == "") {
						$this->MC->core->ram = "1024M";
				} //!isset($this->MC->core->ram) or $this->MC->core->ram == ""
				if (!isset($this->MC->core->users) or $this->MC->core->users == "") {
						$this->MC->core->users = '';
				} //!isset($this->MC->core->users) or $this->MC->core->users == ""
				if (!isset($this->MC->core->backup) or $this->MC->core->backup == "") {
						$this->MC->core->backup = $this->MC->core->pfad . 'backup/';
				} //!isset($this->MC->core->backup) or $this->MC->core->backup == ""
				if (!isset($this->MC->core->log) or $this->MC->core->log == "") {
						$this->MC->core->log = '100';
				} //!isset($this->MC->core->log) or $this->MC->core->log == ""
				if (!isset($this->MC->core->status) or $this->MC->core->status == "") {
						$this->MC->core->status = "";
				} //!isset($this->MC->core->log) or $this->MC->core->log == ""
		}
		function admin_menu_page() {
				add_menu_page(__('Minecraft Admin', 'minecraft-admin'), __('Minecraft', 'minecraft-admin'), 'read', 'minecraft-admin', array(
						&$this,
						'mc_core_info'
				), plugins_url(MC_PLUGIN_DIR . '/includes/images/icon.png'));
				if ($this->MC->server->installed === "ja") {
						add_submenu_page('minecraft-admin', __('Commands | Minecraft Admin', 'minecraft-admin'), __('Commands', 'minecraft-admin'), 'manage_options', 'minecraft-admin?mc=commands', array(
								&$this,
								'mc_core_commands'
						));
						add_submenu_page('minecraft-admin', __('Plugins | Minecraft Admin', 'minecraft-admin'), __('Plugins', 'minecraft-admin'), 'manage_options', 'minecraft-admin?mc=plugins', array(
								&$this,
								'plugins'
						));
						add_submenu_page('minecraft-admin', __('Filebrowser | Minecraft Admin', 'minecraft-admin'), __('Filebrowser', 'minecraft-admin'), "read", 'minecraft-admin?mc=filebrowser', array(
								&$this,
								'filebrowser'
						));
						add_submenu_page('minecraft-admin', __('Recurring action | Minecraft Admin', 'minecraft-admin'), __('Recurring action', 'minecraft-admin'), "read", 'minecraft-admin?mc=cronjob', array(
								&$this,
								'cronjob'
						));
				} //$this->MC->server->installed === "ja"
				add_submenu_page('minecraft-admin', __('Install | Minecraft Admin', 'minecraft-admin'), __('Install', 'minecraft-admin'), "read", 'minecraft-admin?mc=install', array(
						&$this,
						'mc_setup'
				));
		}
		function template($path) {
				$path = WP_PLUGIN_DIR . '/' . MC_PLUGIN_DIR . '/includes/templates/' . $path . '.php';
				if (is_file($path)) {
						include_once($path);
				} //is_file(WP_PLUGIN_DIR . '/' . MC_PLUGIN_DIR . '/' . $plugin . '.php')
				else {
						die(__('MC-ERROR: The MC component file ' . $path . ' couldn\'t be load. Please check your path settings.', 'minecraft-admin'));
				}
		}
		function mc_core_commands() {
				if ($this->MC->server->installed === "ja") {
						$this->template('mc-core/commands');
						if (isset($_GET["p"]) && !empty($_GET["p"])) {
								$output = parse_minecraft_output(shell_exec('sh /etc/init.d/minecraft ' . $_GET["p"]));
								echo "<pre>" . $output . "</pre>";
						} //!empty($_GET["p"])
						else if (!empty($_POST["p"])) {
								$output = parse_minecraft_output(shell_exec('sh /etc/init.d/minecraft command "' . $_POST["p"] . '"'));
								echo "<pre>" . $output . "</pre>";
						} //!empty($_POST["p"])
						echo '<br />';
						$users = parse_minecraft_output(shell_exec('sh /etc/init.d/minecraft command "list"'));
						if (!empty($users)) {
								_e("The following users are online:", "minecraft-admin");
								echo $users;
								$outputs = shell_exec('sh /etc/init.d/minecraft status');
								echo "<pre>" . $outputs . "</pre>";
						} //!empty($users)
						else {
								_e("It seems to be no user are online :(", "minecraft-admin");
						}
						$zaehler = 0;
						$log     = file($this->MC->core->pfad . "server.log");
						$i       = sizeof($log);
						echo '<br /><div id="mc_core_log"><textarea cols="150" rows="' . $this->MC->core->log . '">';
						$z    = 0;
						$ex   = explode("\n", parse_minecraft_output(shell_exec("tail -n " . $this->MC->core->log . " " . $this->MC->core->pfad . "server.log")));
						$zahl = $this->MC->core->log;
						while (true) {
								$i = $zahl - $z;
								echo $ex[$i] . "\n";
								if ($i == 0) {
										break;
								} //$i == 0
								$z++;
						} //true
						echo "</textarea></div>";
				} //$this->MC->server->installed === "nein"
		}
		function mc_ajax_log() {
				$z    = 0;
				$ex   = explode("\n", parse_minecraft_output(shell_exec("tail -n " . $this->MC->core->log . " " . $this->MC->core->pfad . "server.log")));
				$zahl = $this->MC->core->log;
				while (true) {
						$i = $zahl - $z;
						echo $ex[$i] . "\n";
						if ($i == 0) {
								break;
						} //$i == 0
						$z++;
				} //true
		}
		function mc_core_info() {
				if (isset($_POST['submit']) && check_admin_referer('mc-core-components')) {
						foreach ($this->MC as $id => $plugin) {
								if (isset($plugin->name)) {
										$this->MC->$id->aktive = "nein";
								} //isset($plugin->name)
						} //$this->MC as $id => $plugin
						$_POST['mc-core-component']["core"] = "ja";
						foreach ($_POST['mc-core-component'] as $plugin => $akt) {
								$akt                       = ($akt == "ja") ? "ja" : "nein";
								$plugin                    = str_replace('mc-', '', $plugin);
								$this->MC->$plugin->aktive = $akt;
						} //$_POST['mc-core-component'] as $plugin => $akt
						$updated = true;
				} //isset($_POST['submit']) && check_admin_referer('mc-core-components')
				$this->template('mc-core/info');
		}
		function mc_nav() {
				global $wp_admin_bar;
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin',
						'title' => __('Minecraft Admin', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin'
				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-befehl',
						'parent' => 'minecraft-admin',
						'title' => __('Commands', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=commands'
				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-befehl-start',
						'parent' => 'minecraft-admin-befehl',
						'title' => __('start', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=commands&p=start'
				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-befehl-stop',
						'parent' => 'minecraft-admin-befehl',
						'title' => __('stop', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=commands&p=stop'
				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-befehl-restart',
						'parent' => 'minecraft-admin-befehl',
						'title' => __('restart', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=commands&p=restart'
				));
// 				$wp_admin_bar->add_menu(array(
// 						'id' => 'minecraft-admin-server-properties',
// 						'parent' => 'minecraft-admin',
// 						'title' => __('InGame Einstellungen', 'minecraft-admin'),
// 						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=server.properties'
// 				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-cronjob',
						'parent' => 'minecraft-admin',
						'title' => __('recurring actions', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=cronjob'
				));
// 				$wp_admin_bar->add_menu(array(
// 						'id' => 'minecraft-admin-einstellungen',
// 						'parent' => 'minecraft-admin',
// 						'title' => __('settings', 'minecraft-admin'),
// 						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=einstellungen'
// 				));
				$wp_admin_bar->add_menu(array(
						'id' => 'minecraft-admin-filebrowser',
						'parent' => 'minecraft-admin',
						'title' => __('filebrowser', 'minecraft-admin'),
						'href' => get_bloginfo('wpurl') . '/wp-admin/admin.php?page=minecraft-admin?mc=filebrowser'
				));
		}
		function mc_setup() {
				if (isset($_POST["type"]) && check_admin_referer('mc-core-setup', 'mc-core-setup')) {
						if ($_POST["type"] == "install") {
								$this->MC->core->status = "install";
						} //$_POST["type"] == "install"
						elseif ($_POST["type"] == "delete") {
								$this->MC->core->status = "delete";
						} //$_POST["type"] == "delete"
				} //isset($_POST["type"]) && check_admin_referer('mc-core-setup', 'mc-core-setup')
				if (!isset($_GET["p"])) {
						$_GET["p"] = "";
				} //!isset($_GET["p"])
				$oswebserver         = explode("(", $_SERVER['SERVER_SOFTWARE']);
				$os                  = str_replace(")", "", $oswebserver[1]);
				$webserver           = $oswebserver[1];
				$os_unterstuetzt     = false;
				$os_unter            = array(
						'Debian',
						'Ubuntu'
				);
				$os_unter_vielleicht = array(
						'Fedora',
						'openSUSE'
				);
				$os_nicht_unter      = array(
						'Windows'
				);
				foreach ($os_unter as $system) {
						if ($system == $os) {
								$os_unterstuetzt = true;
								break;
						} //$system == $os
				} //$os_unter as $system
				if ($os_unterstuetzt) {
						echo '<div id="message" class="updated"><p><strong>' . __("Your operating system is supported.", "minecraft-admin") . '</strong></p></div>';
				} //$os_unterstuetzt
				else {
						$os_unterstuetzt_vielleicht = false;
						foreach ($os_unter_vielleicht as $system) {
								if ($system == $os) {
										$os_unterstuetzt_vielleicht = true;
										break;
								} //$system == $os
						} //$os_unter_vielleicht as $system
						if ($os_unterstuetzt_vielleicht) {
								echo '<div id="message" class="error"><p><strong>' . __("There are no offical test data for your operating system. <br /> A similar operating system is supported, so it is possible that on your operating system 'Minecraft Admin' runs.", "minecraft-admin") . '</strong></p></div>';
						} //$os_unterstuetzt_vielleicht
						else {
								$os_unterstuetzt_nicht = false;
								foreach ($os_nicht_unter as $system) {
										if ($system == $os) {
												$os_unterstuetzt_nicht = true;
												break;
										} //$system == $os
								} //$os_nicht_unter as $system
								if ($os_unterstuetzt_nicht) {
										echo '<div id="message" class="error"><p><strong>' . __("Your operating system is not supported. <br /> It is not recommended to install 'Minecraft Admin'.", "minecraft-admin") . '</strong></p></div>';
								} //$os_unterstuetzt_nicht
								else {
										echo '<div id="message" class="updated"><p><strong>' . __("There are no offical test data for your operating system. You can still try to install 'Minecraft Admin'.", "minecraft-admin") . '</strong></p></div>';
								}
						}
				}
				echo '<br /><br />';
				if ($this->MC->core->status == "delete") {
						unlink('/etc/init.d/minecraft');
						if (delete_option(MC_OPTION_NAME)) {
								echo '<div id="message" class="updated"><p><strong>' . __('The plugin datas was successfull delete. You can now delete the plugin via the plugins menu', "minecraft-admin") . '</strong></p></div>';
						} //delete_option(MC_OPTION_NAME)
						else {
								echo '<div id="message" class="error"><p><strong>' . __("ERROR: The plugin-datas couldn't be deleted.", "minecraft-admin") . '</strong></p></div>';
						}
						$this->MC->server->installed = "nein";
						$this->MC->core->status      = "";
				} //$this->MC->core->status == "delete"
				else if ($this->MC->core->status == "install") {
						if ($_GET["p"] == 1 || empty($_GET["p"])) {
								$mc_updated = false;
								if (isset($_POST['settings']) && check_admin_referer('mc-core-einstellungen')) {
										foreach ($_POST['mc_settings_options'] as $set => $wert) {
												if (isset($this->MC->core->$set) && $set != "pfad" && $set != "backup") {
														$this->MC->core->$set = $wert;
												} //isset($this->MC->core->$set)
										} //$_POST['mc-core-component'] as $plugin => $akt
										$mc_updated = true;
								} //isset($_POST['submit']) && check_admin_referer('mc-core-components')
								$this->template('mc-core/interne_einstellungen');
								template_interne_einstellungen($this->MC->core, $mc_updated);
						} //$_GET["p"] == 1 || empty($_GET["p"])
						else if ($_GET["p"] == 2) {
								$script = generate_init(false, $this->MC->core);
								if ($os == "Debian" or $os == "Ubuntu") {
										$options = array(
												"webservernutzer" => $this->MC->core->webserveruser,
												"pfad" => $this->MC->core->pfad,
												"backup" => $this->MC->core->pfad . "/backup/",
												"jar" => $this->MC->core->jar,
												"os" => "deb"
										);
								} //$os == "Debian" or $os == "Ubuntu"
								else if ($os == "openSUSE" or $os == "Fedora") {
										$options = array(
												"webservernutzer" => $this->MC->core->webserveruser,
												"pfad" => $this->MC->core->pfad,
												"backup" => $this->MC->core->pfad . "/backup/",
												"jar" => $this->MC->core->jar,
												"os" => "yum"
										);
								} //$os == "openSUSE" or $os == "Fedora"
								else {
										$options = array(
												"webservernutzer" => $this->MC->core->webserveruser,
												"pfad" => $this->MC->core->pfad,
												"backup" => $this->MC->core->pfad . "/backup/",
												"jar" => $this->MC->core->jar,
												"os" => "no"
										);
										_e("Because there are no test data for your operating system, a automatic installer script couldn't be created. Please install Java manually.", "minecraft-admin");
								}
								if (!isset($this->MC->core->server) OR $this->MC->core->server == "orginal") {
										$options["down"] = 'https://s3.amazonaws.com/MinecraftDownload/launcher/minecraft_server.jar?';
								} //$this->MC->core->server'] == "orginal"
								elseif ($this->MC->core->server == "bukkit") {
										$options["down"] = 'http://dl.bukkit.org/latest-rb/craftbukkit.jar';
								} //$this->MC->core->server'] == "bukkit"
								$installer = create_installer($options);
								create_file('/installer.sh', $installer, BP_MC_CORE_PLUGIN_INCLUDES_DIR);
								if (!is_file(BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/minecraft_init_d.sh')) {
										echo '<div id="message" class="error"><p><strong>' . sprintf(__("The file %s couldn't be created. Create it manually.", "minecraft-admin"), "minecraft_init_d.sh") . '</strong></p></div>';
										echo BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/minecraft_init_d.sh<br><textarea>' . $script . '</textarea><br><br>';
								} //!is_file($ordner . '/minecraft_init_d.sh')
								if (!is_file(BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/installer.sh')) {
										echo '<div id="message" class="error"><p><strong>' . sprintf(__("The file %s couldn't be created. Create it manually.", "minecraft-admin"), "installer.sh") . '</strong></p></div>';
										echo BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/installer.sh<br><textarea>' . $installer . '</textarea><br><br>';
								} //!is_file($ordner . '/installer.sh')
								if (is_file(BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/installer.sh') && is_file(BP_MC_CORE_PLUGIN_INCLUDES_DIR . '/minecraft_init_d.sh')) {
										echo '<div id="message" class="updated"><p><strong>' . __("Done! The required file was created.", "minecraft-admin") . '</strong></p></div>';
								} //is_file($ordner . '/installer.sh') && is_file($ordner . '/minecraft_init_d.sh')
								echo '<form method="post" action="admin.php?page=minecraft-admin?mc=install&p=3"><p class="submit"><input type="submit" class="button-primary" value="' . __('go to step 3', 'minecraft-admin') . '" /></p></form>';
						} //$_GET["p"] == 2
						else if ($_GET["p"] == 3) {
								if (is_file('/etc/init.d/minecraft')) {
										$this->MC->server->installed = "ja";
										$this->MC->core->status      = "";
										echo '<div id="message" class="updated"><p><strong>' . __('Congratulations. Your Minecraft should now be installed. Check this ig you login on this server.', 'minecraft-admin') . '</strong></p></div>';
										echo '<div class="wrap"><form method="post" action="admin.php?page=minecraft-admin"><p class="submit"><input type="submit" class="button-primary" value="' . __('Finish', 'minecraft-admin') . '" /></p></form></div>';
								} //is_file('/etc/init.d/minecraft')
								else {
										$befehl_root = 'cd ' . BP_MC_CORE_PLUGIN_INCLUDES_DIR . ' && sh ./installer.sh';
										$befehl_sudo = 'cd ' . BP_MC_CORE_PLUGIN_INCLUDES_DIR . ' && sudo sh ./installer.sh';
										_e('nearly on the end. To exit the installer, run the following command:', 'minecraft-admin');
										if ($os == "Ubuntu") {
												echo '<br><textarea cols="150">' . $befehl_sudo . '</textarea>';
										} //$os == "Ubuntu"
										else {
												echo '<br><textarea cols="150">' . $befehl_root . '</textarea>';
										}
										echo '<br><form method="post" action="admin.php?page=minecraft-admin?mc=install&p=3"><p class="submit"><input type="submit" class="button-primary" value="' . __('go to step 4', 'minecraft-admin') . '" /></p></form>';
								} //is_file($ordner . '/minecraft_init_d.sh')
						} //$_GET["p"] == 3
				} //$this->MC->core->status == "install"
				else {
						$this->template('mc-core/setup_start');
				}
				$this->save();
		}
		function plugins() {
				if (!isset($_GET["cache"])) {
						$_GET["cache"] = "";
				} //!isset($_GET["cache"])
				if ($_GET["cache"] == "false") {
						lochen_verzeichnis($this->MC->core->pfad . ".tmp");
						echo '<meta http-equiv="refresh" content="0; URL=admin.php?page=minecraft-admin?mc=plugins"> ';
				} //$_GET["cache"] == "false"
				echo '<a href="admin.php?page=minecraft-admin?mc=plugins&cache=false">Lösche Cache</a>';
				$val = (!empty($_GET["install"])) ? 'value="' . $_GET["install"] . '"' : "";
				echo '<form action="admin.php" method="GET">
' . __('install', 'minecraft-admin') . ':<input type="text" name="install" placeholder="' . __('plugin name', 'minecraft-admin') . '" ' . $val . '>
<input type="hidden" name="page" value="minecraft-admin?mc=plugins">
    <input type="submit" name="absenden" value="' . __('send', 'minecraft-admin') . '"></form>';
				if (!is_dir($this->MC->core->pfad . ".tmp/")) {
						mkdir($this->MC->core->pfad . ".tmp/");
				} //!is_dir($this->MC->core->pfad . ".tmp/")
				if (!is_file($this->MC->core->pfad . ".tmp/created-by-mc-admin.txt")) {
						touch($this->MC->core->pfad . ".tmp/created-by-mc-admin.txt");
				} //!is_file($this->MC->core->pfad . ".tmp/created-by-mc-admin.txt")
				if (!is_dir($this->MC->core->pfad . "plugins/")) {
						mkdir($this->MC->core->pfad . "plugins/");
				} //!is_dir($this->MC->core->pfad . ".tmp/")
				$handle = opendir($this->MC->core->pfad . "plugins/");
				while ($datei = readdir($handle)) {
						if (mime_content_type($this->MC->core->pfad . "plugins/" . $datei) == "application/zip") {
								if (!is_file($this->MC->core->pfad . ".tmp/$datei.yml")) {
										mkdir($this->MC->core->pfad . ".tmp/plugin-" . str_replace(".jar", "", $datei) . "/");
										exec("unzip " . $this->MC->core->pfad . "plugins/" . $datei . " -d " . $this->MC->core->pfad . ".tmp/plugin-" . str_replace(".jar", "", $datei) . "/");
										exec("cp " . $this->MC->core->pfad . ".tmp/plugin-" . str_replace(".jar", "", $datei) . "/plugin.yml " . $this->MC->core->pfad . ".tmp/" . str_replace(".jar", "", $datei) . ".yml");
										exec("rm -r " . $this->MC->core->pfad . ".tmp/plugin-" . str_replace(".jar", "", $datei));
								} //!is_file($this->MC->core->pfad . ".tmp/$datei.yml")
						} //mime_content_type($this->MC->core->pfad . "plugins/" . $datei) == "application/zip"
				} //$datei = readdir($handle)
				closedir($handle);
				if (empty($val)) {
						echo "<table><tr><th>".__("name","minecraft-admin")."</th><th>".__("version","minecraft-admin")."</th><th>".__("plugin file","minecraft-admin")."</th><th>".__("options","minecraft-admin")."</th><th>".__("Bukkit website","minecraft-admin")."</th><th>".__("Up-To-Date?","minecraft-admin")."</tr>";
						$handle = opendir($this->MC->core->pfad . ".tmp/");
						while ($dateiyml = readdir($handle)) {
								if ($dateiyml != "created-by-mc-admin.txt" && $dateiyml != "." && strpos($dateiyml, ".yml") !== false && $dateiyml != ".." && is_file($this->MC->core->pfad . ".tmp/" . $dateiyml)) {
										$yml = file($this->MC->core->pfad . ".tmp/" . $dateiyml);
										foreach ($yml as $key => $value) {
												$ex = explode(":", $value);
												if ($ex[0] == "name") {
														$name = str_replace(" ", "", $ex[1]);
														$name = str_replace("\n", "", $name);
														$name = str_replace("\r", "", $name);
												} //$ex[0] == "name"
												if ($ex[0] == "version") {
														$version = str_replace(" ", "", strtolower($ex[1]));
														$version = str_replace("\n", "", $version);
														$version = str_replace("\r", "", $version);
												} //$ex[0] == "version"
										} //$yml as $key => $value
										$rss_url = 'http://dev.bukkit.org/server-mods/' . $name . '/files.rss';
										if (!is_file($this->MC->core->pfad . ".tmp/" . $name . ".rss")) {
												exec('wget ' . $rss_url . ' -O ' . $this->MC->core->pfad . ".tmp/" . $name . ".rss");
										} //!is_file($this->MC->core->pfad . ".tmp/" . $name . ".rss")
										$uptodate = false;
										$error    = false;
										$xml      = @simplexml_load_file($this->MC->core->pfad . ".tmp/" . $name . ".rss");
										if (empty($xml->channel->item) or $xml->channel->item == "" or $xml->channel->item == " ") {
												if (!is_file($this->MC->core->pfad . ".tmp/" . $name . ".html")) {
														exec('wget "http://dev.bukkit.org/server-mods/' . $name . '/files/" -O ' . $this->MC->core->pfad . '.tmp/' . $name . '.html --no-check-certificate');
												} //!is_file($this->MC->core->pfad . ".tmp/" . $name . ".html")
												$bukkitorg = file($this->MC->core->pfad . ".tmp/" . $name . ".html");
												if (!empty($bukkitorg)) {
														foreach ($bukkitorg as $id => $lines) {
																if (!empty($lines)) {
																		$lines = str_replace(" ", "", strtolower($lines));
																		$lines = str_replace("\n", "", $lines);
																		$lines = str_replace("\r", "", $lines);
																		if (strpos($lines, "noresultsfound") !== false) {
																				$error = __("There aren't downloads anymore.","minecraft-admin");
																				// break 1;
																		} //strpos($lines, "noresultsfound") !== false
																		elseif (strpos($lines, '<h3>login</h3>') !== false) {
																				$error = __("The plugin wasn't found.","minecraft-admin");
																				// break 1;
																		} //strpos($lines, '<h3>login</h3>') !== false

																		/*
																		elseif(strpos($lines, '404notfound')!== false  ){
																		$error = "Plugin konnte nicht gefunden werden!";
																		// break 1;
																		}*/
																} //!empty($lines)
														} //$bukkitorg as $id => $lines
												} //!empty($bukkitorg)
												else {
														$error = __("The plugin wasn't found.","minecraft-admin");
												}
										} //empty($xml->channel->item) or $xml->channel->item == "" or $xml->channel->item == " "
										else if (!empty($xml->channel->item) && $xml->channel->item != "" && $xml->channel->item != " ") {
												foreach ($xml->channel->item as $id => $item) {
														$version_ohne_klammern = preg_replace('#\(.*?\)#m', '', $version);
														$title_ohne_klammern   = preg_replace('#\(.*?\)#m', '', $item->title);
														$cross                 = $this->array_cartesian(array(
																$version_ohne_klammern,
																$version,
																"v" . $version,
																strtolower($name) . " " . $version_ohne_klammern,
																strtolower($name) . " v" . $version_ohne_klammern,
																strtolower($name) . " " . $version,
																strtolower($name) . " v" . $version
														), array(
																$title_ohne_klammern,
																strtolower($item->title),
																"v" . strtolower($item->title)
														));
														$cross                 = (empty($cross)) ? array() : $cross;
														foreach ($cross as $arr) {
																if ($arr[0] == $arr[1]) {
																		$uptodate = true;
																		break;
																} //$arr[0] == $arr[1]
														} //$cross as $arr
												} //$xml->channel->item as $id => $item
										} //!empty($xml->channel->item) && $xml->channel->item != "" && $xml->channel->item != " "
										unset($item);
										unset($xml);
										$errors = (empty($error) && $error === false) ? "Update" : $error;
										$up     = ($uptodate) ? "Ja" : $errors;
										echo "<tr><td>$name</td><td>$version</td><td>" . str_replace(".yml", ".jar", $dateiyml) . '</td><td>comming soon</td><td>
<a href="http://dev.bukkit.org/server-mods/' . $name . '/">'.__("Bukkit Dev","minecraft-admin").'</a></td><td>' . $up . '</td></tr>';
										unset($name);
										unset($version);
										unset($uptodate);
										unset($error);
								} //$datei != "created-by-mc-admin.txt" && $datei != "." && $datei != ".." && is_file($this->MC->core->pfad . ".tmp/" . $datei)
						} //$datei = readdir($handle)
						closedir($handle);
						echo "</table>";
				} //empty($val)
				else {
						$includes = array(
								'/Snoopy.class.php'
						);
						parent::includes(BP_MC_CORE_PLUGIN_INCLUDES_DIR, $includes);
						$snoopy = new Snoopy;
						if (!empty($_GET["download"])) {
								$name    = str_replace("/server-mods/", "", $_GET["download"]);
								$name    = str_replace("/", "", $name);
								$rss_url = 'http://dev.bukkit.org' . $_GET["download"] . 'files.rss';
								exec('wget ' . $rss_url . ' -O ' . $this->MC->core->pfad . ".tmp/" . $name . ".rss");
								$xml  = simplexml_load_file($this->MC->core->pfad . ".tmp/" . $name . ".rss");
								$link = (string) $xml->channel->item[0]->link;
								$snoopy->fetch($link);
								$erste     = explode('<li class="user-action user-action-download">', $snoopy->results);
								$zweite    = explode('Download', $erste[1]);
								$zweite[0] = str_replace('<span><a href="', "", $zweite[0]);
								$zweite[0] = str_replace('">', "", $zweite[0]);
								exec('wget ' . $zweite[0] . ' -O ' . $this->MC->core->pfad . "plugins/" . $name . ".jar");
								exec('sh /etc/init.d/minecraft restart');
								echo '<meta http-equiv="refresh" content="0; URL=admin.php?page=minecraft-admin?mc=plugins"> ';
						} //!empty($_GET["download"])
						$snoopy->fetch("http://dev.bukkit.org/search/?scope=projects&search=" . $_GET["install"]);
						$explode  = explode('<div class="listing-container">', $snoopy->results);
						$explodes = explode('<div class="listing-pagination listing-pagination-bottom">', $explode[1]);
						//                                 $lines = str_replace(" ", "", $explodes[0]);
						$lines    = $explodes[0];
						$lines    = preg_replace('/<td class="col-search-entry"><h2><a href="(.*)">(.*)<\/a><\/h2><\/td>/', '<td class="col-search-entry"><h2><a href="$1">$2</a></h2><br /><a href="admin.php?page=minecraft-admin?mc=plugins&install=' . $_GET["install"] . '&download=$1" style="    background: none repeat scroll 0 0 green;    color: white;">'.__("install","minecraft-admin").'</a></td>', $lines);
						$lines    = str_replace("\n", "", $lines);
						$lines    = str_replace("\r", "", $lines);
						$lines    = str_replace('<td class="col-status"></td>', "", $lines);
						$lines    = str_replace('<colgroup><col/><col/><col/><col/></colgroup>', "", $lines);
						$lines    = str_replace('<td colspan="4" class="summary">', '<td></td><td></td><td colspan="4" class="summary">', $lines);
						$lines    = str_replace('<span><span></span></span>', '', $lines);
						$lines    = str_replace('href="/', 'href="http://dev.bukkit.org/', $lines);
						$lines    = str_replace('<thead><tr><th scope="col" class="col-status single-col"></th>', '', $lines);
						print($lines);
				}
		}
		function array_cartesian() {
				$_ = func_get_args();
				if (!empty($_)) {
						if (count($_) == 0) {
								return array(
										array()
								);
						} //count($_) == 0
						$a = array_shift($_);
						$c = call_user_func_array(array(
								$this,
								__FUNCTION__
						), $_);
						if (!empty($c)) {
								$r = array();
								foreach ($a as $v) {
										foreach ($c as $p) {
												$p   = str_replace(" ", "", strtolower($p));
												$p   = str_replace("\n", "", $p);
												$p   = str_replace("\r", "", $p);
												$v   = str_replace(" ", "", strtolower($v));
												$v   = str_replace("\n", "", $v);
												$v   = str_replace("\r", "", $v);
												$r[] = array_merge(array(
														$v
												), $p);
										} //$c as $p
								} //$a as $v
								return $r;
						} //!empty($c)
				} //!empty($_)
		}
		function filebrowser() {
				if (!isset($_GET["path"]) or empty($_GET['path']))
						$_GET['path'] = "/";
				$path = $_GET['path'];
				if (!empty($_GET["lochen"])) {
						$res  = lochen_verzeichnis($this->MC->core->pfad . $path);
						$path = substr($path, 0, strrpos($path, "/"));
						switch ($res) {
								case 0:
										_e("The directory was deleted successfully.", 'minecraft-admin');
										break;
								case -1:
										_e("Error: This isn't a directory", 'minecraft-admin');
										break;
								case -2:
										_e("Error: The directory wasn't deleted successfully. Reason: unknown", 'minecraft-admin');
										break;
								case -3:
										_e("Error: The directory wasn't deleted successfully. Reason: filetype unknown", 'minecraft-admin');
										break;
								default:
										_e("Error: The directory wasn't deleted successfully. Reason: The delete function seems to be incorrect. Inform the author.", 'minecraft-admin');
										break;
						} //$res
						echo '<br />';
				} //!empty($_GET["lochen"])
				if (!empty($_FILES["datei"]["tmp_name"])) {
						$uploadFile = $this->MC->core->pfad . $path . '/' . $_FILES['datei']['name'];
						echo "<pre>";
						if (move_uploaded_file($_FILES['datei']['tmp_name'], $uploadFile)) {
								echo _e("The file was successfully uploaded.", 'minecraft-admin');
						} //move_uploaded_file($_FILES['datei']['tmp_name'], $uploadFile)
						else {
								echo _e("The file wasn't successfully uploaded.", 'minecraft-admin');
						}
						echo "</pre>";
				} //!empty($_FILES["datei"]["tmp_name"])
				else if (!empty($_POST["neu"])) {
						rename($this->MC->core->pfad . $path, $this->MC->core->pfad . substr($path, 0, strrpos($path, "/")) . '/' . $_POST["neu"]);
						$path = substr($path, 0, strrpos($path, "/")) . '/' . $_POST["neu"];
				} //!empty($_POST["neu"])
				else if (!empty($_POST["neuerstellen"])) {
						var_dump(strpos($_POST["neuerstellen"], '.'));
						if (strpos($_POST["neuerstellen"], '.')) {
								$path = $path . '/' . $_POST["neuerstellen"];
								$fp   = fopen($this->MC->core->pfad . $path, "w+");
								fwrite($fp, "#test");
								fclose($fp);
								clearstatcache();
						} //strpos($_POST["neuerstellen"], '.')
						else {
								mkDir($this->MC->core->pfad . $path . '/' . $_POST["neuerstellen"]);
						}
				} //!empty($_POST["neuerstellen"])
				echo '<a href="admin.php?page=minecraft-admin?mc=filebrowser&path=/">'.__("Minecraft","minecraft-admin").'</a>/';
				if ($path != '' or $path != '/') {
						$expath  = explode('/', $path);
						$gesamnt = count($expath);
						for ($i = 0; $i < $gesamnt; $i++) {
								$url = '';
								for ($r = 0; $r < $i; $r++) {
										$url .= '/' . $expath[$r + 1];
								} //$r = 0; $r < $i; $r++
								if (!empty($expath[$i])) {
										echo '<a href="admin.php?page=minecraft-admin?mc=filebrowser&path=' . $url . '">' . $expath[$i] . '</a>';
										if (!is_file($this->MC->core->pfad . $url)) {
												echo '/';
										} //!is_file($this->MC->core->pfad . $url)
								} //!empty($expath[$i])
						} //$i = 0; $i < $gesamnt; $i++
				} //$path != '' or $path != '/'
				echo '<br>';
				if (is_file($this->MC->core->pfad . $path)) {
						if (isset($_POST["inhalt"])) {
								$fp = fopen($this->MC->core->pfad . $path, "w+");
								fwrite($fp, str_replace('\\', "", $_POST["inhalt"]));
								fclose($fp);
								clearstatcache();
						} //isset($_POST["inhalt"])
						if (substr($path, 0, strrpos($path, "/")) == "") {
								$zuruck = "admin.php?page=minecraft-admin?mc=filebrowser&path=/";
						} //substr($path, 0, strrpos($path, "/")) == ""
						else {
								$zuruck = "admin.php?page=minecraft-admin?mc=filebrowser&path=" . substr($path, 0, strrpos($path, "/"));
						}
						echo '<div class="wrap"><h2>' . $path . '</h2><a href="' . $zuruck . '">' . __("back", "minecraft-admin") . '</a><form method="post" action=""><textarea name="inhalt" rows="25" cols="100">';
						$datei         = file($this->MC->core->pfad . $path);
						$ausgabe_datei = '';
						foreach ($datei as $key => $value) {
								$ausgabe_datei .= $value;
						} //$datei as $key => $value
						echo $ausgabe_datei . '</textarea><p class="submit"><input type="submit" class="button-primary" value="' . __("Save changes", 'minecraft-admin') . '" /></p></form></div><form method="POST" action=""><a href="admin.php?page=minecraft-admin?mc=filebrowser&path=' . $path . '&lochen=true"><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/images/filebrowser/folder_delete.png" alt="[' . __("Delete", 'minecraft-admin') . ']" /></a><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/images/filebrowser/folder_edit.png" alt="[' . __("rename", 'minecraft-admin') . ']" /> <input type="text" name="neu" /><input type="submit" class="button-primary" value="' . __("rename", 'minecraft-admin') . '" /></form>';
				} //is_file($this->MC->core->pfad . $path)
				else {
						$dir      = opendir($this->MC->core->pfad . $path);
						$array    = array();
						$arrayneu = array();
						while ($file = readdir($dir)) {
								$filepath = $this->MC->core->pfad . $path . "/" . $file;
								$stat     = stat($filepath);
								if ($file != "." and $file != ".." and $file != "aufgaben.crontab" and $file != ".tmp") {
										$filetypebyphp = mime_content_type($filepath);
										if (strpos($filepath, ".") !== false) {
												$filetypebyown = explode('.', $filepath);
												$filetypebyown = (isset($filetypebyown[1]) ? $filetypebyown[1] : $filetypebyown[0]);
												if (is_file(str_replace("wp-admin/admin.php", "", $_SERVER['SCRIPT_FILENAME']) . 'wp-content/plugins/minecraft-admin/images/filebrowser/file_extension_' . $filetypebyown . '.png')) {
														if ($filetypebyown != $filetypebyphp) {
																$filetype = $filetypebyown;
														} //$filetypebyown != $filetypebyphp
														else {
																$filetype = $filetypebyphp;
														}
												} //is_file(str_replace("wp-admin/admin.php", "", $_SERVER['SCRIPT_FILENAME']) . 'wp-content/plugins/minecraft-admin/images/filebrowser/file_extension_' . $filetypebyown . '.png')
												else {
														$filetype = $filetypebyphp;
												}
										} //strpos($filepath, ".") !== false
										else {
												$filetype = $filetypebyphp;
										}
										$array[$filetype][] = array(
												'zugriff' => date("d-m-Y, H:i:s", $stat[8]),
												'anderung' => date("d-m-Y, H:i:s", $stat[9]),
												'size' => binary_multiples($stat[7], true, false),
												'file' => $file
										);
								} //$file != "." and $file != ".." and $file != "aufgaben.crontab"
						} //$file = readdir($dir)
						closedir($dir);
						foreach ($array as $id => $inhalt) {
								usort($inhalt, "cmp");
								$arrayneu[$id] = $inhalt;
						} //$array as $id => $inhalt
						echo "<table>";
						foreach ($arrayneu as $id => $inhalt) {
								foreach ($inhalt as $unterid => $unterinhalt) {
										$id_nachher = explode("/", $id);
										$id_nachher = (isset($id_nachher[1]) ? $id_nachher[1] : $id_nachher[0]);
										if (!is_file(str_replace("wp-admin/admin.php", "", $_SERVER['SCRIPT_FILENAME']) . 'wp-content/plugins/minecraft-admin/includes/images/filebrowser/file_extension_' . $id_nachher . '.png')) {
												$id_nachher = "unkown";
										} //!is_file(str_replace("wp-admin/admin.php", "", $_SERVER['SCRIPT_FILENAME']) . 'wp-content/plugins/minecraft-admin/images/filebrowser/file_extension_' . $id_nachher . '.png')
										echo '<tr  class="mc_admin_hidden_false">
            <td><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/includes/images/filebrowser/file_extension_' . $id_nachher . '.png" alt="[' . $id . ']" /></td>
            <td>
               <table class="mc_admin_hidden"><tr>
               <td>' . __("Last access", "minecraft-admin") . ':</td>
               <td> ' . $unterinhalt["zugriff"] . '</td></tr><tr>
               <td>' . __("size", "minecraft-admin") . ':</td>
               <td> ' . $unterinhalt["size"] . '</td></tr><tr>
               <td>' . __("last change", "minecraft-admin") . ':</td>
               <td> ' . $unterinhalt["anderung"] . '</td></tr><tr>
               <td><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/includes/images/filebrowser/folder_edit.png" alt="[' . __("rename", 'minecraft-admin') . ']" /></td>
               <td><form style="margin:0;" method="POST" action="admin.php?page=minecraft-admin?mc=filebrowser&path=' . (($path == "/") ? "" : $path) . '/' . rawurlencode($unterinhalt["file"]) . '"> <input type="text" name="neu" value="' . $unterinhalt["file"] . '"/></form></td></tr><tr>
               <td><a href="admin.php?page=minecraft-admin?mc=filebrowser&path=' . (($path == "/") ? "" : $path) . '/' . rawurlencode($unterinhalt["file"]) . '&lochen=true"><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/includes/images/filebrowser/folder_delete.png" alt="[' . __("Delete", 'minecraft-admin') . ']" /></a></td>
               <td></td></tr>
               </table>
            </td>
            <td><a href="admin.php?page=minecraft-admin?mc=filebrowser&path=' . (($path == "/") ? "" : $path) . '/' . rawurlencode($unterinhalt["file"]) . '">' . $unterinhalt["file"] . '</a></td></tr>';
								} //$inhalt as $unterid => $unterinhalt
						} //$arrayneu as $id => $inhalt
						echo '<tr><td><img src="' . get_bloginfo("wpurl") . '/wp-content/plugins/minecraft-admin/includes/images/filebrowser/folder_add.png" alt="[' . __("new", "minecraft-admin") . ']" /></td><td></td><td><form action="" method="POST"><input name="neuerstellen" type="text" /><input type="submit" class="button-primary" value="' . __("create", 'minecraft-admin') . '" /></form></td><td></td></tr></table><form enctype="multipart/form-data" action="" method="post">' . __("Choose a file to be uploaded", 'minecraft-admin') . ': <input name="datei" type="file"><input type="submit" value="' . __("Upload file", 'minecraft-admin') . '"></form>';
						if ($path != "/" XOR !empty($path) XOR $path != '') {
								echo '<a href="admin.php?page=minecraft-admin?mc=filebrowser&path=' . $path . '&lochen=true">' . __("Delete actually directory.", 'minecraft-admin') . '</a><form method="POST" action="">' . __("rename actually directory.","minecraft-admin") . ' <input type="text" name="neu" /><input type="submit" class="button-primary" value="' . __("rename", 'minecraft-admin') . '" /></form>';
						} //$path != "/" XOR !empty($path) XOR $path != ''
				}
		}
		function cronjob() {
				$prog = $this->MC->core->pfad . "aufgaben.crontab";
				if (!is_file($prog)) {
						touch($prog);
				} //!is_file($prog)
				if (isset($_GET["id"])) {
						$properties = file($prog);
						unlink($prog);
						exec("touch " . $prog);
						$dat = fopen($prog, "w");
						unset($properties[$_GET["id"]]);
						$properties = array_values($properties);
						foreach ($properties as $key => $value) {
								if (!empty($value) or $value != " ") {
										fwrite($dat, $value);
								} //!empty($value) or $value != " "
						} //$properties as $key => $value
						fclose($dat);
						exec("crontab $prog");
						echo '<meta http-equiv="refresh" content="0; URL=admin.php?page=minecraft-admin?mc=cronjob"> ';
				} //isset($_GET["id"])
				if (!empty($_POST["befehl"])) {
						if (is_array($_POST["min"])) {
								foreach ($_POST["min"] as $key => $value) {
										if (!isset($min)) {
												$min = $value;
										} //!isset($min)
										else {
												$min .= ',' . $value;
										}
								} //$_POST["min"] as $key => $value
						} //is_array($_POST["min"])
						else {
								$min = $_POST["min"];
						}
						if ($min == "") {
								$min = "*";
						} //$min == ""
						if (is_array($_POST["hour"])) {
								foreach ($_POST["hour"] as $key => $value) {
										if (!isset($hour)) {
												$hour = $value;
										} //!isset($hour)
										else {
												$hour .= ',' . $value;
										}
								} //$_POST["hour"] as $key => $value
						} //is_array($_POST["hour"])
						else {
								$hour = $_POST["hour"];
						}
						if ($hour == "") {
								$hour = "*";
						} //$hour == ""
						if (is_array($_POST["day"])) {
								foreach ($_POST["day"] as $key => $value) {
										if (!isset($day)) {
												$day = $value;
										} //!isset($day)
										else {
												$day .= ',' . $value;
										}
								} //$_POST["day"] as $key => $value
						} //is_array($_POST["day"])
						else {
								$day = $_POST["day"];
						}
						if ($day == "") {
								$day = "*";
						} //$day == ""
						if (is_array($_POST["month"])) {
								foreach ($_POST["month"] as $key => $value) {
										if (!isset($month)) {
												$month = $value;
										} //!isset($month)
										else {
												$month .= ',' . $value;
										}
								} //$_POST["month"] as $key => $value
						} //is_array($_POST["month"])
						else {
								$month = $_POST["month"];
						}
						if ($month == "") {
								$month = "*";
						} //$month == ""
						if (is_array($_POST["week"])) {
								foreach ($_POST["week"] as $key => $value) {
										if (!isset($week)) {
												$week = $value;
										} //!isset($week)
										else {
												$week .= ',' . $value;
										}
								} //$_POST["week"] as $key => $value
						} //is_array($_POST["week"])
						else {
								$week = $_POST["week"];
						}
						if ($week == "") {
								$week = "*";
						} //$week == ""
						if (!is_file($prog)) {
								exec("touch " . $prog);
						} //!is_file($prog)
						if ($_POST["befehl"] == "command") {
								$befehl = "sh /etc/init.d/minecraft command " . $_POST["mcbefehl"];
						} //$_POST["befehl"] == "command"
						else {
								$befehl = "sh /etc/init.d/minecraft " . $_POST["befehl"];
						}
						echo '<div class="updated">';
						exec("echo \"$min $hour $day $month $week $befehl\" >> $prog");
						exec("crontab $prog");
						_e('recurring action was successfully created', 'minecraft-admin');
						echo '</div>';
				} //!empty($_POST["befehl"])
				echo '<table><tr><th>' . __('Id', 'minecraft-admin') . '</th><th>' . __('minute', 'minecraft-admin') . '</th><th>' . __('hour', 'minecraft-admin') . '</th><th>' . __('day', 'minecraft-admin') . '</th><th>' . __('month', 'minecraft-admin') . '</th><th>' . __('weeksday', 'minecraft-admin') . '</th><th>' . __('command', 'minecraft-admin') . '</th><th>' . __("delete", "minecraft-admin") . '</th></tr>';
				$properties = file($prog);
				foreach ($properties as $key => $value) {
						$explode = explode("sh /etc/init.d/minecraft", $value);
						$leer    = explode(" ", $explode[0]);
						foreach ($leer as $zähler => $zahl) {
								if ($zahl == '*') {
										$leer[$zähler] = __("all","minecraft-admin");
								} //$zahl == '*'
						} //$leer as $zähler => $zahl
						$bef    = explode(" ", $explode[1]);
						$bef[1] = str_replace("\n", "", $bef[1]);
						if ($bef[1] == "command") {
								$befehl = __('minecraft command', 'minecraft-admin') . ': <div style="color:green;">';
								foreach ($bef as $id => $rest) {
										if ($id != 0 && $id != 1) {
												$befehl .= $rest . ' ';
										} //$id != 0 && $id != 1
								} //$bef as $id => $rest
								$befehl .= '</div>';
						} //$bef[1] == "command"
						elseif ($bef[1] == "start") {
								$befehl = __('start', 'minecraft-admin');
						} //$bef[1] == "start"
								elseif ($bef[1] == "stop") {
								$befehl = __('stop', 'minecraft-admin');
						} //$bef[1] == "stop"
								elseif ($bef[1] == "restart") {
								$befehl = __('restart', 'minecraft-admin');
						} //$bef[1] == "restart"
								elseif ($bef[1] == "backup") {
								$befehl = __('backup', 'minecraft-admin');
						} //$bef[1] == "backup"
						echo '<tr><td>' . ($key + 1) . '.</td><td>' . $leer[0] . '</td><td>' . $leer[1] . '</td><td>' . $leer[2] . '</td><td>' . $leer[3] . '</td><td>' . $leer[4] . '</td><td>' . $befehl . '</td><td><a href="admin.php?page=minecraft-admin?mc=cronjob&id=' . $key . '">' . __("Delete", "minecraft-admin") . '</a></td></tr>';
						unset($befehl);
				} //$properties as $key => $value
				echo '</table>';
				$this->template('mc-core/cronjobs');
		}
}
?>